<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Project 10</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 10</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Electronics Design</li>
            <li>Learn to use KiCad</li>
            <li>Make it practical</li>
        </hl>
    </section>

    <section>
        <h1>KiCad</h1>
        <p>
            So, I have decided to take the pluge and learn how to use the ATtiny412 microcontroller
            in my board design. I made this decision based on the advice from both the global lecture and
            the local lecture which both indicated the high capabilities of the device as well as the low cost.
            In order to reduce the cost and impact of this design and future designs, I am looking forward to utilizing
            the
            "fit for function" mentality; that I will only use components which are able to accomplish their desired
            task, without any
            addition waste of connections or processing power.
        </p>
        <p>
            Just to begin, I have to say that I have never had any exposure to any PCB manufacturing. While I was a
            middle-school teacher, I taught
            introductory electronics to students, but we did not go further than the V=IR formula, learning about
            parallel and series circuits, and learning
            how to use a voltmeter, ammeter, and multimeter. Mostly it was learning through playing with usually
            resulted in a lot of burnt out light bulbs.
            As this was my first PCB, I followed along with the local lecture instructional video to learn the basics of
            populating the board with components in KiCad,
            as well as learning terminology that I will need to learn in the future such as pin connectors, bypass
            capacitors, UDPI connectors...etc. These are all quite new to me
            so it is difficult to know what the name of a component that I need is, although I can picture it in my
            mind.
        </p>
        <h1>Basic Theory</h1>
        <p>
            To begin, there is a rather simple looking formula which indicates the relationship between voltage (V),
            current (I), and resistance (R). V=IR: Voltage = Current x Resistance. Votage can be considered the pushing
            force of electrons, the current is how many electrons
            are able to be pushed, and the resistance is an obstacle which restricts the movement of electrons. Although
            a bit counterintuitive for a chemist, electrons flow from the positive (+) terminal in a circuit to the
            negative terminal (-). Why I say counterintuitive is that
            electrons posses a net negative charge. Therefor it is strange for them to both possess a negative charge,
            and flow to a negative terminal as electrostatic interaction can be summarized in quite a simple way of,
            "opposites attract"; negatively charged electrons should
            flow towards a positive (electron deficient) terminal.
        </p>
        <p>
            So here is where the formula works. As a specific voltage is supplied to the system (approximately 5V with
            USB, additional available with power connectors), voltage can be considered as a constant for these basic
            calculations. We can also make an incorrect assumption for simplicity
            that the wires that the electrons flow through have no resistance. Aside from that, each component in a
            circuit either consumes amperage to perform an action, or provides resistance to decrease the flow of
            electrons. We will look and analyze an LED for this purpose and why
            resistors are needed to safeguard the electronic components of the LED. A link to the LED webpage is <a
                href="https://optoelectronics.liteon.com/upload/download/DS-22-98-0002/LTST-C150CKT.pdf">here</a>.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture8.JPG" width="500px">
            <img src="Project10Images/Capture9.JPG" width="500px">
        </div>
        <p>
            The calculations done in the image above are concerning the calculation for the resistance of the resistor
            that is necessary for an LED to function without over-current. Using the LED guide above, the forward
            voltage of the LED was 2.4V, which means that
            2.4V are required to act on the LED to push current through. With a 5V current, 2.4V is "consumed" by the
            LED to push current through. When we do the calculation 5V - 2.4V, we are left with 2.6V (not 3.6V like in
            the image...oops), which means that we require a resistor of
            130 ohms. As the maximum current that the LED can sustain is 0.04A (40mA), a 100 ohm resistor should be
            sufficient to maintain the amperage between 20mA and 40mA. Therefor, a 100 ohm resistor was chosen to be
            added to the KiCad circuit.
        </p>
        <p>
            Once I created the board in KiCad following the local lecture instructional video, I started researching the
            ATtiny chip and
            what the different outputs are. Lots of information was found in the data booklet for the device, but
            unfortunately
            it provided a huge amount of information condensed into a very large PDF which made it rather
            incomprehensible for someone
            who had never previously used a microcontroller and was still learning the basics. <a
                href="https://www.microchip.com/en-us/product/attiny412">Here</a> is a link to the website where you can
            download the datasheet.
        </p>
        <p>

        </p>

        <h1>ATTINY412</h1>
        <p>
            **INCLUDE A SECTION WITH BASICS OF ATTiny412**
        </p>
        <p>
            I began by designing a board in KiCad using the ATtiny412 as the microcontroller. I placed 2 different LED
            lights (different colours) on the board, as well as a tactile switch and a UPDI input connector so that I
            can program the ATtiny412. I also
            added a power connector so that the board can be powered by a 5V external power source once I have
            programmed it with the UPDI connector. Additionally, I added a 2x2 connector for providing power and
            transmission (TX) and receiving (RX) capabilities to the ATtiny412 in case I wanted
            to program it to communicate with other transmitting and receiving devices.

        </p>
        <div class="image-container">
            <img src="Project10Images/Capture10.JPG" width="1000px">
        </div>
        <div class="image-container">
            <img src="Project10Images/Capture1.JPG" width="500px">
            <img src="Project10Images/Capture2.JPG" width="500px">
        </div>
        <div class="image-container">
            <img src="Project10Images/Capture3.JPG" width="500px">
            <img src="Project10Images/Capture4.JPG" width="500px">
        </div>
        <div class="image-container">
            <img src="Project10Images/Capture5.JPG" width="500px">
            <img src="Project10Images/Capture6.JPG" width="500px">
        </div>
        <div class="image-container">
            <img src="Project10Images/Capture7.JPG" width="500px">
        </div>
        <p>
            After finishing the "rats nest" mess of connections that appeared on the pcb editor, the final board design
            looked very nice. I created a copper fill where the whole copper surface will act as a PWR_GROUND, so this
            simplified all of the
            ground connections on the board. After completing this, I completed the electrical rules checker to ensure
            that all of my connections were made properly and that I was not missing any information. For the future, I
            NEED to remember to set the path width to
            the proper value at the start of the pcb creation. I then output the file to a GERBER file-type which can be
            utilized by the copper cad program that is used to create the proper output file for the SRM-20 milling
            machine.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture11.jpg" width="500px">
            <img src="Project10Images/Capture12.jpg" width="500px">
        </div>
        <p>
            Once the GERBER file was exported from KiCad and imported into CopperCAD, I started receiving some strange
            error messages which were quite difficult to decipher and fix. I attempted to push through with the error
            messages and follow the previous instructions
            provided by the previous milling tutorial to complete the board. On the image (above left) you can see a
            sample of the error message, and the other image (top right), you can see the final result from the milling
            machine. Tracks were not milled properly, and the outside
            edges of the machine were not milled to the proper depth.
        </p>
        <p>
            Here I tried to again export the file from KiCad, import into CopperCAD, and try again. This unfortunately
            did not function again and the same issue occurred. I tried modifying the depth, the track thickness, and
            some placements on the board in the hopes of solving the issue.
            Unfortunately, they all failed. I also tried drilling the holes, which also failed (image below). LUCKILY,
            this was an issue that the teacher had observed before and it was a simple fix once I was able to show him
            the errors that I observed.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture13.jpg" width="500px">
        </div>
        <p>
            The solution to all of the above problems was that copperCAD was not correctly importing the borders of the
            designed PCB. This was solved very quickly by manually setting the borders in copperCAD by right-clicking on
            the edges and manually setting the borders.
            After this quick solution was discovered, everything worked perfectly with the milling process.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture14.jpg" width="500px">
            <img src="Project10Images/Capture15.jpg" width="500px">
        </div>
        <p>
            Now it was time to populate the board by soldering on all of the hardware that I had selected in the KiCad
            FAB equipment selection screen. As this was simple soldering (like in a previous project), I did not take
            images of each soldered device.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture16.jpg" width="500px">
            <img src="Project10Images/Capture17.jpg" width="500px">
        </div>
        <div class="image-container">
            <img src="Project10Images/Capture18.jpg" width="500px">
        </div>
        <p>
            The device was finally completed (preliminarily), and I checked all of the circuits using a multimeter to
            ensure that they the items were properly connected and soldered.
        </p>
    </section>

    <section>
        <h1>Programming the ATtiny412 and testing the board</h1>
        <p>
            Testing the board was done using the ATtiny412 communication board that was available in the FabLab. A board
            manager was needed, and was downloaded from <a
                href="https://www.electronics-lab.com/project/using-new-attiny-processors-arduino-ide-attiny412-attiny1614-attiny3216-attiny1616-attiny3217/">here</a>
            and followed the installation guide, this was to be able to program the ATtiny412 using the arduino legacy
            IDE.

        </p>
        <div class="image-container">
            <img src="Project10Images/Capture19.jpg" width="500px">
        </div>
        <p>
            Once the basic setup was completed, programming went rather smoothly by following the instructions in the
            above provided link. Simply powering on the LED was rather simple, and it functioned!
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture20.jpg" width="500px">
        </div>
        <p>
            However, I had some really big difficulties with the pin location of the board when using the Arduino IDE. I
            followed the pin locations from the pin out that is in the ATtiny datasheet, but unfortunately this
            did not work. I then tried to use the PA1, PA2, PA3 pinout names, which also didn't work. Luckily, I found a
            FabAcademy student who had solved the issue with the ATtiny412 pinout and had provided for everyone
            <a href="https://github.com/SpenceKonde/megaTinyCore/blob/master/megaavr/extras/ATtiny_x12.md">here</a>. The
            issue that I had was that I was using the board pinout including the PWR and GND, but I should have been
            using the
            analog/digital pinout which is provided in the previous link. Once this was solved, I was able to start
            doing more with the board. Unfortunately, I already had an issue getting the button and second LED to work,
            and I tried a... not so
            intelligent method of testing it.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture21.jpg" width="500px">
            <img src="Project10Images/Capture22.jpg" width="500px">
        </div>
        <p>
            I provided power to each component using a provided power supply at 3.2V. This actually worked rather well
            until I got a bit cocky and decided to provide power to pins that were not supposed to be powered on the
            ATtiny412.....or at least
            not powered directly. After this mistake...the board was fried. I could no longer communicate with the
            ATtiny412 using the UPDI connector.
        </p>
        <div class="image-container">
            <img src="Project10Images/Capture25.jpg" width="500px">
        </div>
        <p>Back to the soldering table to replace the ATtiny412 with a new one...</p>
        <div class="image-container">
            <img src="Project10Images/Capture26.jpg" width="500px">
            <img src="Project10Images/Capture27.jpg" width="500px">
        </div>
        <p>Once the new ATtiny was connected to the board...everything worked out very well and I could upload programs
            with the proper pinout (analog/digital). Here are some cool videos of what I could make the board do. </p>
        <video width="320" height="240" controls>
            <source src="Project10Images/Video1.mp4" type="video/mp4">
        </video>
        <video width="320" height="240" controls>
            <source src="Project10Images/Video2.mp4" type="video/mp4">
        </video>
        <video width="320" height="240" controls>
            <source src="Project10Images/Video3.mp4" type="video/mp4">
        </video>
        <video width="320" height="240" controls>
            <source src="Project10Images/Video4.mp4" type="video/mp4">
        </video>
        <p> Here is a snippet of the code that I used for the party blink code (video 2)</p>
        <div class="image-container">
            <img src="Project10Images/PartyBlinkCode.JPG" width="500px">
        </div>
    </section>




</body>

</html>